#include <cis-workflow-gen/quick-include.hpp>

int main() {
    auto flow =
        Activity("CreateResGrp", "FleetAGC.Activities.InitResourceGroupActivity")
            .addInputSetting("ResourceGroup", "WdsTest")
        >> Activity("CreateVM", "FleetAGC.Activities.CreateAzureResourceActivity")
            .addInputSetting("ResourceGroup", "WdsTest")
            .addInputSetting("DeploymentName", "DeployVM")
            .addInputSetting("TemplateFilePath", "Resources/ArmTemplates/VM/Template_winserver2016.json")
            .addInputSetting("ParameterFilePath", "Resources/ArmTemplates/VM/Parameters_WDS.json")
        >> Activity("GetVmInfo", "FleetAGC.Activities.QueryAzureVMsActivity")
            .addInputSetting("ResourceGroup", "WdsTest")
        >> Activity("InstallWdsServices", "FleetAGC.Activities.RemotePSActivity")
            .addInputSetting("PublicIP", CS(GlobalSettings["BootstrapWDSPublicIPAddress"]))
            .addInputSetting("UserNameKey", "DC1AdminUserName")
            .addInputSetting("PasswordKey", "DC1AdminPassword")
            .addInputSetting("ScriptPath", "Resources/PSScript/WdsOneClick.ps1")
            .addInputSetting("RequiresSAS","true")
        >> Activity("WaitForWdsInstallFinish", "FleetAGC.Activities.RemotePSActivity")
            .addInputSetting("PublicIP", CS(GlobalSettings["BootstrapWDSPublicIPAddress"]))
            .addInputSetting("UserNameKey", "DC1AdminUserName")
            .addInputSetting("PasswordKey", "DC1AdminPassword")
            .addInputSetting("RetryTime", "2000")
            .addInputSetting("RetryInterval", "1")
            .addInputSetting("ScriptPath", "Resources/PSScript/WdsOneClick_CheckSuccess.ps1")
        ;

    println(to_file("DeployWdsTestServerWorkflow.xaml"), flow.generateXaml("Microsoft.Office.FleetAGC.Workflows.DeployWdsTestServerWorkflow"));
    // println(to_file("BootstrapCAWorkflow.xaml"), flow.generateXaml("Microsoft.Office.FleetAGC.Workflows.BootstrapCAWorkflow"));
}

